package jp.littlesoft.gwttest1.server;

import jp.littlesoft.gwttest1.client.ImageSearchResultSet;
import jp.littlesoft.gwttest1.client.ImageSearchService;
import jp.littlesoft.gwttest1.server.YahooImageSearchResultHandler;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

public class ImageSearchServiceImpl extends RemoteServiceServlet implements
    ImageSearchService {

  public ImageSearchResultSet execute(int start, int size, String keyword) throws Exception {
    
    String requestParam = 
      "http://api.search.yahoo.co.jp/ImageSearchService/V1/imageSearch" +
      "?appid=Search001" +
      "&query=" + java.net.URLEncoder.encode("\"" + keyword + "\"", "UTF-8") +
      "&start=" + start + "&results=" + size;
    
    ImageSearchResultSet resultSet = new ImageSearchResultSet();
    java.net.URL url = new java.net.URL(requestParam);
    java.net.HttpURLConnection urlCon = (java.net.HttpURLConnection)url.openConnection();
    try {
      org.xml.sax.InputSource ins = new org.xml.sax.InputSource(urlCon.getInputStream());
      javax.xml.parsers.SAXParserFactory fact = javax.xml.parsers.SAXParserFactory.newInstance();
      javax.xml.parsers.SAXParser parser = fact.newSAXParser();
      YahooImageSearchResultHandler handler = new YahooImageSearchResultHandler(resultSet);
      parser.parse(ins, handler);
    } finally {
      urlCon.getInputStream().close();
      urlCon.disconnect();
    }
    return resultSet;
  }
}
